/*****************************************************************/
/* ߣ
 * Emialfishyxj@sina.com
 * 2011.9.28
 * ܣԶʼϵͳԶϵͳʼ
/*****************************************************************/

using System;
using System.Net;
using System.Net.Mail;
using System.Net.Mime;
namespace XFish.Utils
{
    /// <summary>  
    /// ʼ
    /// </summary>  
    public class EMailTransmitter
    {
        #region ڲ
        private MailMessage _MailMessage;
        private SmtpClient _SmtpClient;
        private string _Password;
        #endregion

        #region 
        /// <summary>
        /// ʼ
        /// </summary>
        public string Body
        {
            get { return _MailMessage.Body; }
            set { _MailMessage.Body = value; }
        }
        /// <summary>
        /// ʼ
        /// </summary>
        public string Title
        {
            get { return _MailMessage.Subject; }
            set { _MailMessage.Subject = value; }
        }
        /// <summary>
        /// 
        /// </summary>
        public string Password
        {
            get { return _Password; }
            set { _Password = value; }
        }
        #endregion

        #region ʼ
        /// <summary>  
        /// ˺ʵ  
        /// </summary>  
        /// <param name="To">ռ˵ַ</param>  
        /// <param name="From">˵ַ</param>  
        /// <param name="Body">ʼ</param>  
        /// <param name="Title">ʼ</param>  
        /// <param name="Password"></param>  
        public EMailTransmitter(string to, string from, string body, string title, string password)
        {
            _MailMessage = new MailMessage();
            _MailMessage.To.Add(to);
            _MailMessage.From = new System.Net.Mail.MailAddress(from);
            _MailMessage.Subject = title;
            _MailMessage.Body = body;
            _MailMessage.IsBodyHtml = true;
            _MailMessage.BodyEncoding = System.Text.Encoding.UTF8;
            _MailMessage.Priority = System.Net.Mail.MailPriority.Normal;
            _Password = password;
        }
        #endregion

        #region ෽
        /// <summary>
        /// ӽշַ
        /// </summary>
        /// <param name="to">շʼַ</param>
        public void AddReceiver(string to)
        {
            MailAddress address = new MailAddress(to);
            if (!_MailMessage.To.Contains(address))
                _MailMessage.To.Add(to);
        }
        /// <summary>
        /// ɾָĽշַ
        /// </summary>
        /// <param name="to">շʼַ</param>
        public void RemoveReceiver(string to)
        {
            MailAddress address = new MailAddress(to);
            if (_MailMessage.To.Contains(address))
                _MailMessage.To.Remove(address);
        }
        /// <summary>
        /// Ӹ
        /// </summary>
        /// <param name="Path">·</param>
        public void AddAttachments(string path)  
        {  
            string[] paths = path.Split(',');  
            Attachment data;  
            ContentDisposition disposition;  
            for (int i = 0; i < paths.Length; i++)  
            {  
                data = new Attachment(paths[i], MediaTypeNames.Application.Octet);//ʵ  
                disposition = data.ContentDisposition;  
                disposition.CreationDate = System.IO.File.GetCreationTime(paths[i]);//ȡ Ĵ  
                disposition.ModificationDate = System.IO.File.GetLastWriteTime(paths[i]);//ȡ޸  
                disposition.ReadDate = System.IO.File.GetLastAccessTime(paths[i]);//ȡĶȡ  
                _MailMessage.Attachments.Add(data);//ӵ  
            }  
        }
        /// <summary>
        /// ɾ
        /// </summary>
        /// <param name="path">·</param>
        public void RemoveAttachments(string path)
        {
            string[] paths = path.Split(',');
            Attachment data;
            ContentDisposition disposition;  
            for (int i = 0; i < paths.Length; i++)
            {
                data = new Attachment(paths[i], MediaTypeNames.Application.Octet);
                disposition = data.ContentDisposition;  
                disposition.CreationDate = System.IO.File.GetCreationTime(paths[i]);//ȡ Ĵ  
                disposition.ModificationDate = System.IO.File.GetLastWriteTime(paths[i]);//ȡ޸  
                disposition.ReadDate = System.IO.File.GetLastAccessTime(paths[i]);//ȡĶȡ  
                if(_MailMessage.Attachments.Contains(data))
                    _MailMessage.Attachments.Remove(data);
            }
        }
        /// <summary>  
        /// 첽ʼ  
        /// </summary>  
        /// <param name="CompletedMethod">ɺõ¼</param>  
        public void SendAsync(SendCompletedEventHandler CompletedMethod)
        {
            if (_MailMessage != null)
            {
                _SmtpClient = new SmtpClient();
                _SmtpClient.Credentials = new System.Net.NetworkCredential(_MailMessage.From.Address, _Password);//÷ݵƱ  
                _SmtpClient.DeliveryMethod = System.Net.Mail.SmtpDeliveryMethod.Network;
                _SmtpClient.Host = "smtp." + _MailMessage.From.Host;
                _SmtpClient.SendCompleted += new SendCompletedEventHandler(CompletedMethod);//ע첽ʼʱ¼  
                _SmtpClient.SendAsync(_MailMessage, _MailMessage.Body);
            }
        }
        /// <summary>  
        /// ʼ  
        /// </summary>  
        public void Send()
        {
            if (_MailMessage != null)
            {
                _SmtpClient = new SmtpClient();
                _SmtpClient.Credentials = new System.Net.NetworkCredential(_MailMessage.From.Address, _Password);//÷ݵƱ  
                _SmtpClient.DeliveryMethod = System.Net.Mail.SmtpDeliveryMethod.Network;
                _SmtpClient.Host = "smtp." + _MailMessage.From.Host;
                _SmtpClient.Send(_MailMessage);
            }
        }
        #endregion
    }
}